#include<iostream>
#include<fstream>
#include<cctype>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<unistd.h>
#include<errno.h>
#include<sys/types.h>
#include<sys/wait.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>
#include<netdb.h>
#include"mysock.h"
#define DBG(a)  printf("%s = %d\n", #a, a)
#define NOOP    ((char*)"NOOP\r\n")

using namespace std;
mysock_client client;
mysock_server server;
char * host = NULL;
char * port = (char *)"21";
char username[1024];
char password[1024];
char buf[1024];
char buf1[1024];
bool pasv = true;
char pasv_port[20];
bool set_pasv();
void dologin();
void shell();
void lcd();
void pwd();
void cd();
void get();
void put();
void del();
void dir();
void quit();

int main(int argc, char * argv[]){
    if(argc < 2){
        printf("Usage: %s <IP|Domain_name> <PORT>\n", argv[0]);
        exit(1);
    }
    host = argv[1];
    if(argc > 2) port = argv[2];
    client.conn(host, port);
    if(client.connected() == false) {
        printf("Can't connect to server (%s:%p)\n", host, port);
        return 1;
    }
    client.sendline(NOOP);
    int len, status;
    while (len = client.recvline(buf), len > 0){
        buf[len] = 0;
        sscanf(buf, "%d", &status);
        if(status != 220) break;
    }
    dologin();

    char cmd[30];
    while (true){ //循环处理用户输入的命令
        fflush(stdin);
        printf("ftp> ");
        if(gets(buf) == NULL) quit();
        sscanf(buf, "%10s", cmd);
        for(int i = 0; cmd[i]; ++i){
            if(cmd[i] <= 'z' && cmd[i] >= 'a') 
                cmd[i] -= 32;
        }
        if(cmd[0] == '!'){
            shell();
        }else if(strcmp(cmd, "LCD") == 0){
            lcd();
        }else if(strcmp(cmd, "PWD") == 0){
            pwd();
        }else if(strcmp(cmd, "CD") == 0){
            cd();
        }else if(strcmp(cmd, "GET") == 0){
            get();
        }else if(strcmp(cmd, "PUT") == 0){
            put();
        }else if(strcmp(cmd, "DEL") == 0){
            del();
        }else if(strcmp(cmd, "DIR") == 0){
            dir();
        }else if(strcmp(cmd, "QUIT") == 0){
            quit();
        }else{
            printf("Illegal Command. Supported commands are: \n");
            printf("lcd, pwd, cd, put, get, del, dir, quit.\n");
            printf("Command with a prefix \"!\" will run in the shell.\n");
        }
    }
    return 0;
}

void dologin(){
    int len;
    int status;
    while(true){ //循环直至登陆成功
        //用户名
        printf("Username: "); 
        scanf("%s", username);
        getchar();
        sprintf(buf, "USER %s\r\n", username);
        client.sendline(buf);
        client.recvline(buf);
        sscanf(buf, "%d", &status);
        if(status != 331) continue;

        fflush(stdin);
        //密码
        printf("Password: ");
        scanf("%s", password);
        getchar();
        sprintf(buf, "PASS %s\r\n", password);
        client.sendline(buf);
        client.recvline(buf);
        sscanf(buf, "%d", &status);
        if(status == 230)break;
    }
} 

void put(){
    char file[1024], *p;
    int len;
    for (p = buf; *p; p++){
        if(*p == ' ') {
            p++; 
            break;
        }
    }
    strcpy(file, p);
    FILE *fp = fopen(file, "r");
    if (fp == NULL){
        printf("Can't open file\n");
        return;
    }
    set_pasv();
    sprintf(buf1, "STOR %s\r\n", file);
    printf("%s", buf1);
    client.sendline(buf1);
    if(pasv){
        mysock_client sender(host, pasv_port);
        if(sender.connected() == false){
            printf("Unable to connect to server (%s:%s)\n", host, pasv_port);
        }
        client.recvline(buf);
        while(len = fread(buf, 1, 1000, fp), len > 0){
            sender.sendmsg(buf, len);
            if(len < 1000) break;
        }
        sender.quit();
        client.recvline(buf);
        printf("Data transferred.\n");
    }else{
        printf("Not pasv. Not Completed.\n");
    }
    fclose(fp);
}

void pwd(){
    int i;
    client.sendline((char *)"PWD\r\n");
    client.recvline(buf);
}

void cd(){
    int len = strlen(buf);
    if(len == 2) {
        pwd();
        return;
    }
    buf[len+1] = 0;
    char *p;
    for (p = buf; *p; p++){
        if(*p == ' ') break;
    }
    sprintf(buf1, "CWD%s\r\n", p);
    client.sendline(buf1);
    client.recvline(buf);
}

void get(){
    char *p, file[1024];
    int len;
    for (p = buf; *p; p++){
        if(*p == ' ') {
            p++; 
            strcpy(file, p);
            printf("FILE: %s~\n", file);
            break;
        }
    }
    set_pasv();
    client.sendline((char*)"TYPE I\r\n");
    client.recvline(buf1);
    sprintf(buf1, "RETR %s\r\n", file);
    client.sendline(buf1);
    if(pasv){
        mysock_client recver(host, pasv_port);
        if(recver.connected() == false){
            printf("Unable to connect to server (%s:%s)\n", host, pasv_port);
        }
        client.recvline(buf);
        int status;
        sscanf(buf, "%d", &status);
        if(status == 550){
            recver.quit();
            return;
        }
        int datalen;
        char *p = NULL;
        for(p = buf;*p != '('; p++);
        sscanf(p, "(%d", &datalen);
        printf("Data length: %d\n", datalen);
        client.recvline(buf);
        char f_buf[64];
        FILE *fp = fopen(file, "w");
        if (fp == NULL){
            printf("Can't open file for write\n");
            return;
        }
        while(datalen > 0){
            if (datalen >= 64){
                len = recver.recvmsg(f_buf, 64);
                fwrite(f_buf, 1, 64, fp);
            }else{
                len = recver.recvmsg(f_buf, datalen);
                fwrite(f_buf, 1, datalen, fp);
                break;
            }
            datalen -= 64;
        }
        fclose(fp);
        recver.quit();
        printf("Data transferred.\n");
    }else{
        printf("Not pasv. Not Completed.\n");
    }
}

void dir(){
    set_pasv();
    client.sendline((char*)"LIST\r\n");
    if(pasv){
        mysock_client recver(host, pasv_port);
        if(recver.connected() == false){
            printf("Unable to connect to server (%s:%s)\n", host, pasv_port);
        }
        client.recvline(buf);
        while(true){
            int i = recver.recvmsg(buf, 64);
            buf[i] = 0;
            printf("%s", buf);
            if(i < 64) break;
        }
        recver.quit();
        client.recvline(buf);
        //printf("Data transferred.\n");
    }else{
        printf("Not pasv. Not Completed.\n");
    }
}

void quit(){
    client.sendline((char*)"QUIT\r\n");
    client.recvline(buf);
    client.quit();
    exit(0);
}

bool set_pasv(){
    int status;
    client.sendline((char*)"PASV\r\n");
    client.recvline(buf);
    sscanf(buf, "%d", &status);
    if(status == 227){
        pasv = 1;
        for(int i = 0; buf[i]; ++i){
            if(buf[i] == '('){
                int a, b;
                sscanf(buf+i, "(%*d,%*d,%*d,%*d,%d,%d)", &a, &b);
                sprintf(pasv_port, "%d", a * 256 + b);
                printf("PASV PORT: %s\n", pasv_port);
                break;
            }
        }
        return true;
    }else{
        pasv = 0;
        return false;
    }
}

void shell(){
    if(buf[1] == 0) return;
    system(buf+1);
}

void lcd(){
    char *p;
    for (p = buf; *p; p++){
        if(*p == ' ') break;
    }
    if(*p == 0) {
        system("pwd");
        return;
    }
    p++;
    if(chdir(p) == 0){
        printf("Changed to %s\n", p);
    }else{
        printf("Failed to change to %s\n", p);
    }
}

void del(){
    char buf1[1024];
    int len = strlen(buf);
    if(len == 3)  return;
    char *p;
    for (p = buf; *p; p++){
        if(*p == ' ') break;
    }
    sprintf(buf1, "DELE%s\r\n", p);
    client.sendline(buf1);
    client.recvline(buf);
}

