#ifndef __mysock__
#define __mysock__

class mysock{
protected:
    int err;
    char *errstr;
    int sockfd;
    struct sockaddr_in host;
public:
    //初始化, sockfd = -1
    mysock();
    bool connected();
    int sendmsg(char * buf, int len);
    int recvmsg(char * buf, int len);
    int sendline(char *buf);
    int recvline(char *buf);
    bool quit();
    void dealerr();
};

class mysock_client: public mysock{
public:
    //初始化, sockfd = -1
    mysock_client();
    //给出server和port字符串初始化
    mysock_client(char *server_str, char *port_str);
    //给出server和port字符串连接
    int conn(char *server_str, char *port_str);
};

class mysock_server: public mysock{
public:
    //初始化, sockfd = -1
    mysock_server();
    //给出server和port字符串初始化
    mysock_server(char *port_str);
    //给出server和port字符串连接
    bool conn(char *port_str);
};

#endif
